;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname cc1-gr2) (read-case-sensitive #t) (teachpacks ((lib "valrose.rkt" "installed-teachpacks"))) (htdp-settings #(#t write mixed-fraction #t #t none #f ((lib "valrose.rkt" "installed-teachpacks")) #f)))
;;;
;;; cc1-gr2.rkt

;;; Q1

(define (somme n)          ; n entier
  (+ n (somme (- n 1))))   ; sans if, dans une recurrence, serieux ?...
; Cette fonction plante pour tout n entier, elle diverge vers -infini.
; Il faut un CAS DE BASE pour une récurrence, sur lequel le cas general
; va finir par converger !!!

;;; Q2

(define (inverse n)        ; 1 + 1/2 + 1/3 + ... + 1/n   pour entier >= 0
  (if (= n 0)
      0
      (+ (inverse (- n 1)) (/ 1 n))))

(show (inverse 100))       ; une monstrueuse fraction
(show (exact->inexact (inverse 100)))    ; approximation inexacte en double precision
; NB : si je tape (inverse 100) au toplevel, je peux voir beaucoup plus de chiffres !!!

;;; Q3

(define (ligne n)
  (if (= n 0)
      empty-image
      (beside (circle 20 'solid "yellow") (ligne (- n 1)))))

(show (ligne 4))

;;; Q4

(define (pyramide n)
  (if (= n 0)
      empty-image
      (above (pyramide (- n 1)) (ligne n))))

(show (pyramide 3))

;;; Q5 - Animation

; a) Le monde est (x,y,alpha), position et orientation par l'angle alpha (le "cap")

(define-struct monde (x y alpha))      ; on ne conserve pas l'image de la trajectoire
(define INIT (make-monde 250 300 0))   ; cf enonce

; b) 
(define (suivant m)
  (local [(match-define (monde x y alpha) m)
          (define xs (+ x (* 5 (cos alpha))))     ; avance dans la direction de son cap
          (define ys (- y (* 5 (sin alpha))))]
    (if (= (random 6) 0) 
        (make-monde xs ys (+ alpha 0.4))          ; changement de cap
        (make-monde xs ys alpha))))               ; dans le meme cap

; c)

(define fourmi (bitmap "fourmi.png"))
(define FOND (empty-scene 500 500))

(define (dessiner m)
  (place-image (rotate (* (monde-alpha m) (/ 180 pi)) fourmi)   ; conversion radians->degres !
               (monde-x m)
               (monde-y m)
               FOND))

; d)

(define (final? m)
  (> (monde-alpha m) (+ (* 2 pi) 0.4)))

; e)

(big-bang INIT
          (on-tick suivant 1/20)
          (on-draw dessiner)
          (stop-when final?))

;;;--------------- fourmilliere (voir page web) -----------------

(define (fourmilliere)
  (local [(define SCENE (place-image (circle 30 'solid "black") 
                                     400 100 (rectangle 600 200 'outline "white")))
          (define ORANGE (rectangle 800 10 'solid "orange"))
          (define FRAISE (rectangle 800 10 'solid (make-color 255 0 0)))
          (define FOND (place-image ORANGE 400 6
                                    (place-image FRAISE 400 195 SCENE)))
          (define FOURMI (scale 0.5 (bitmap "fourmi.png")))
          (define (rad->deg theta) 
            (* theta (/ 180 pi)))
          (define (small-random x)    ; inexact aleatoire dans ]-x,x[
            (- (* 2 x (random)) x))
          (define-struct fourmi (x y v theta))   ; v = vitesse, theta = direction
          ; le monde est une liste L de fourmis, 1 seule à l'origine
          (define (random-fourmi)
            (make-fourmi 405 100 (+ 2 (* 3 (random))) (+ pi (small-random 0.2))))
          (define INIT (list (random-fourmi)))
          (define (bouge p)
            (local [(match-define (fourmi x y v theta) p)
                    (define xs  (+ x (* v (cos theta))))     ; position suivante
                    (define ys (+ y (* v (sin theta))))
                    (define thetas (+ theta (small-random 0.1)))
                    (define thetass (+ theta (small-random 0.15)))]   ; chut !
              ; test de collision avec la confiture :-)
              (cond ((< ys 10) (make-fourmi x y v thetass))   ; dans la confit d'orange
                    ((> ys 190) (make-fourmi x y v thetas))   ; dans la confit de fraises
                    (else (make-fourmi xs ys v thetas)))))
          (define (suivant L)
            (if (= (random 15) 0)
                (cons (random-fourmi) (map bouge L))    ; (map sqr '(1 2 3 4)) --> (1 4 9 16)
                (map bouge L)))
          (define (dessiner L)
            (if (empty? L)
                FOND
                (local [(match-define (fourmi x y v theta) (first L))]
                  (place-image (rotate (rad->deg (- theta)) FOURMI) x y (dessiner (rest L))))))] 
    (big-bang INIT
              (on-tick suivant 1/8) 
              (on-draw dessiner))))

(fourmilliere)


































