;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname cc1-gr3) (read-case-sensitive #t) (teachpacks ((lib "valrose.rkt" "installed-teachpacks"))) (htdp-settings #(#t write mixed-fraction #t #t none #f ((lib "valrose.rkt" "installed-teachpacks")) #f)))
;;;
;;; cc1-gr3.rkt

;;; Q1

(define (boulets n)     ; n entier >= 0
  (if (= n 0)
      0
      (+ n (boulets (- n 1)))))

(check-expect (boulets 5) 15)

;;; Q2

(define (boulets_direct n)       ; resolution de la recurrence
  (quotient (* n (+ n 1)) 2))    ; formule bien connue 1 + 2 + 3 + ... + n = n(n+1)/2

;;; Q3

(define (pyramide-3D n)          ; nombre de boulets sur pyramide 3D a base triangulaire
  (if (= n 0)
      0
      (+ (boulets n) (pyramide-3D (- n 1)))))

;;; Complement analogue a Q2 : quelle est la formule polynomiale pour (pyramide-3D n) ? Hors-sujet...

(check-expect (pyramide-3D 5) 35)    ; 15 + 10 + 6 + 3 + 1

;;; Q4

(define (ligne n c)   ; une ligne de n carrés de côté c
  (if (= n 0)
      empty-image
      (beside (rectangle c c 'outline "black")
              (ligne (- n 1) c))))

(show (ligne 10 20))

;;; Q5

(define (damier-slow p q c)    ; un damier de p lignes contenant chacune q colonnes, lent
  (if (= p 0)
      empty-image
      (above (ligne q c)       ; recalcul de (ligne q c) chaque fois :-(
             (damier-slow (- p 1) q c))))

(show (damier-slow 5 10 20))

(define (damier p q c)         ; un damier de p lignes contenant chacune q colonnes
  (local [(define lig (ligne q c))   ; une seule fois !
          (define (aux p)      ; recurrence sur p seulement
            (if (= p 0)
                empty-image
                (above lig (aux (- p 1)))))]
    (aux p)))

(show (damier 5 10 20))

;;; Q6 - Animation d'un monde a 2 parametres.
;;; Rien d'extraordinaire, juste : la primitive (freeze img), hors-sujet !
;;; Une image n'est pas un bitmap mais une suite de constructions qui sont
;;; executees chaque fois qu'on veut le rendu graphique de l'image. Ce qui,
;;; lorsque l'image devient compliquee, ralentit l'animation. Pour cela,
;;; on "gele" (freeze) l'image en un vrai bitmap de temps en temps, ici
;;; chaque seconde (tous les 28 ticks)...

(define (anim)
  (local [(define FOND (damier 4 4 200))
          ; A chaque top d'horloge, j'ai besoin de connaitre l'image courante img
          ; mais aussi l'heure courante t en ticks pour pouvoir stopper au bout de 15 sec.
          (define-struct monde (img t))
          (define INIT (make-monde FOND 0))
          (define (random-color)
            (make-color (random 256) (random 256) (random 256)))
          (define (suivant m)        ; monde --> monde
            (local [(match-define (monde img t) m)     ; destructuration du monde courant
                    (define img-opt
                      (if (= 0 (modulo t 28)) (freeze img) img))    ; simple optimisation, hors-sujet !
                    (define i (random 5))     ; prochaine ligne
                    (define j (random 5))]    ; prochaine colonne
              (make-monde (place-image (underlay (rectangle 199 199 'solid (random-color))
                                                 (rectangle 200 200 'outline "black"))   ; la bordure (pas grave)
                                       (+ 100 (* 200 i)) (+ 100 (* 200 j)) img-opt)
                          (+ t 1))))
          (define (dessiner m)       ; monde --> scene
            (monde-img m))
          (define (final? m)         ; monde --> boolean
            (> (monde-t m) (* 15 28)))]      ; 28 img/sec pendant 15 secondes
    (big-bang INIT
              (on-tick suivant)              ; horloge au 1/28 sec
              (on-draw dessiner)
              (stop-when final?))))

(show (anim))

;;; NB : si l'on connait la primitive (current-seconds), on pouvait eviter le define-struct
;;; et prendre pour monde uniquement img.
(show (current-seconds))
(sleep 2)
(show (current-seconds))














































